﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports MagLib
Imports PdfLib
Imports System.IO.Ports
Imports Ekc
'needed to build a scan or swipe

Imports IDParser_VB.BuffMgr
'needed to save app.config

Imports IDParser_VB.IDParser_VB.Properties




'USB VCP driver class, suggested use to overcome bug on first use of port.
'***************************************************************

' Tokenworks PDF417 and Magnetic Stripe Parsing Library         

' © Copyright 2019 TokenWorks Inc.   All rights reserved.       

' Redistribution and use of this code in source and/or binary   

' forms, with or without modification, are permitted provided   

' that: (1) all copies of the source code retain the above      

' unmodified copyright notice and this entire unmodified        

' section of text, (2) You or Your organization owns a valid    

' Developer License to this product from TokenWorks Inc.        

' and, (3) when any portion of this code is bundled in any      

' form with an application, a valid notice must be provided     

' within the user documentation, start-up screen or in the      

' help-about section of the application that specifies          

' TokenWorks as the provider of the Software bundled            

' with the application.                                         

'***************************************************************

' SDK version 3.7 - Desktop ID/DL Parsing library demo 
' SDK version 3.8 - Improve last name/Title parser for last name with spaces
Namespace IDParser_VB
    Partial Public Class frmMain
        Inherits Form
        Private mc As MagLib.Magstripe
        Private bc As PdfLib.Barcode
#Region " Local Variables"
        Public Shared comport As New SerialPort()
        Public Shared portz As String 'use a global string instead of the default settings
        Private stateP_DL As String
        Private cityP_DL As String
        Private addrP_DL As String
        Private firstnameP_DL As String
        Private lastnameP_DL As String
        Private titleP_DL As String
        Private midnameP_DL As String
        Private dlP_DL As String
        Private expP_DL As String
        Private dobyearP_DL As String
        Private dobMMDDP_DL As String
        Private zipP_DL As String
        Private HeightP_DL As String
        Private EyeColorP_DL As String
        Private SexP_DL As String
        Private ClassP_DL As String
        Private RestrictionsP_DL As String
        Private EndorsementsP_DL As String
        Private WeightP_DL As String
        Private HairP_DL As String

        Private MagBuff As Byte() = New Byte(314) {}
        'Magstrip reader buffer size limit
        Private buff As Byte() = New Byte(1999) {}
        ' PDF417 barcode reader buffer size limit
        Private Rawbuff As Byte() = New Byte(1999) {}
        ' RawData buffer 
        Private displaystring As String
        Private ss1 As Integer = 0
        'start sentinel 1
        Private ss2 As Integer = 1
        'start sentinel 2
        Private ss3 As Integer = 2
        'start sentinel 3
        Private MBD As Integer = 3
        'Magstripe Barcode Designator
        Private d1 As DateTime = DateTime.Now
#End Region

        Public Sub New()

            'reload the ftdi USB driver, fixes issue where driver fails to load on PC boot
            InitializeComponent()

            ' When data is recieved through the port, call this method
            AddHandler comport.DataReceived, New SerialDataReceivedEventHandler(AddressOf port_DataReceived)

            'Initialize the time stamp

            ReaderBuffMgr.GetTimeStamp()
        End Sub

#Region " Local Functions"

        ''' <summary> Convert a string of hex digits (ex: E4 CA B2) to a byte array. </summary>
        ''' <param name="s"> The string containing the hex digits (with or without spaces). </param>
        ''' <returns> Returns an array of bytes. </returns>
        Public Shared Function HexStringToByteArray(ByVal s As String) As Byte()
            s = s.Replace(" ", "")
            Dim buffer As Byte() = New Byte(s.Length / 2 - 1) {}
            Dim i As Integer = 0
            While i < s.Length
                buffer(i / 2) = Convert.ToByte(s.Substring(i, 2), 16)
                i += 2
            End While
            Return buffer
        End Function

        ''' <summary> Converts an array of bytes into a formatted string of hex digits (ex: E4 CA B2)</summary>
        ''' <param name="data"> The array of bytes to be translated into a string of hex digits. </param>
        ''' <returns> Returns a well formatted string of hex digits with spacing. </returns>
        Public Function ByteArrayToHexString(ByVal data As Byte()) As String
            Dim sb As New StringBuilder(data.Length * 3)
            For Each b As Byte In data
                sb.Append(Convert.ToString(b, 16).PadLeft(2, "0"c).PadRight(3, " "c))
            Next
            Return sb.ToString().ToUpper()
        End Function



#End Region

#Region " Events"

        Private Sub port_DataReceived(ByVal sender As Object, ByVal e As SerialDataReceivedEventArgs)

            ' Obtain the number of bytes waiting in the port's buffer
            Dim bytes As Integer = comport.BytesToRead

            ' Create a byte array buffer to hold the incoming data
            Dim buffer As Byte() = New Byte(bytes - 1) {}

            ' Read the data from the port and store it in our buffer
            comport.Read(buffer, 0, bytes)
            ReaderBuffMgr.DataBuilder(buffer, Environment.TickCount)
            d1 = DateTime.Now
            'update timestamp
            'test for a complete scan before calling pdf417 parsing
            If (ReaderBuffMgr.RawBytes(ss1) = &H1) AndAlso (ReaderBuffMgr.RawBytes(ss2) = &H2) AndAlso (ReaderBuffMgr.RawBytes(ss3) = &H5D) AndAlso (ReaderBuffMgr.RawBytes(MBD) = &H4C) AndAlso (ReaderBuffMgr.RawBytes(ReaderBuffMgr.PrevLng - 1) = &H4) Then
                Array.Resize(buff, ReaderBuffMgr.PrevLng)
                'You MUST resize the global to pass only current data
                ReaderBuffMgr.RawBytes(ReaderBuffMgr.PrevLng) = 0
                'insert null to create printable string
                Array.Copy(ReaderBuffMgr.RawBytes, 4, buff, 0, ReaderBuffMgr.PrevLng)
                'you Must strip off the 4 pre-fix bytes inserte by the scanner
                ReaderBuffMgr.PrevLng = 0
                'reset conters
                ReaderBuffMgr.count = 0
                'for next scan
                Try
                    ' always call the DLLs with a try/catch
                    Me.Invoke(New EventHandler(AddressOf SendPDF))
                Catch
                    MessageBox.Show("Invalid Barcode")
                End Try


                displaystring = PdfLib.Barcode.PDF_String
                Me.Invoke(New EventHandler(AddressOf SetText))
            End If

            'test for magstripe read from scanner
            If (ReaderBuffMgr.RawBytes(ss1) = 1) AndAlso (ReaderBuffMgr.RawBytes(ss2) = 2) AndAlso (ReaderBuffMgr.RawBytes(ss3) = &H5D) AndAlso (ReaderBuffMgr.RawBytes(MBD) = &H4D) AndAlso (ReaderBuffMgr.RawBytes(ReaderBuffMgr.PrevLng - 1) = &H4) Then
                Array.Resize(MagBuff, ReaderBuffMgr.PrevLng)
                'You MUST resize the global to pass only current data
                ReaderBuffMgr.RawBytes(ReaderBuffMgr.PrevLng) = 0
                'insert null to create printable string
                Array.Copy(ReaderBuffMgr.RawBytes, 4, MagBuff, 0, ReaderBuffMgr.PrevLng)
                'you Must strip off the 4 pre-fix bytes inserte by the scanner
                ReaderBuffMgr.PrevLng = 0
                'reset counters
                ReaderBuffMgr.count = 0
                'for next swipe
                Try
                    ' always call the DLLs with a try/catch
                    Me.Invoke(New EventHandler(AddressOf SendMAG))
                Catch
                    MessageBox.Show("Invalid Magstripe")
                End Try


                displaystring = MagLib.Magstripe.track1 + MagLib.Magstripe.track2 + MagLib.Magstripe.track3
                Me.Invoke(New EventHandler(AddressOf SetText))
            End If

            'this will catch bad barcode reads
            If (ReaderBuffMgr.RawBytes(ss1) = 1) AndAlso (ReaderBuffMgr.RawBytes(ss2) = 2) AndAlso (ReaderBuffMgr.RawBytes(ss3) = &H4E) AndAlso (ReaderBuffMgr.RawBytes(MBD) = &H52) AndAlso (ReaderBuffMgr.RawBytes(ReaderBuffMgr.PrevLng - 1) = &H4) Then
                ReaderBuffMgr.PrevLng = 0
                ReaderBuffMgr.count = 0

                displaystring = vbCr & vbLf & " Bad Barcode Read, Try Again"

                Me.Invoke(New EventHandler(AddressOf SetText))
            End If

            'this catches the ACK from the Ping command
            If (ReaderBuffMgr.RawBytes(0) = &H6) AndAlso (ReaderBuffMgr.PrevLng = &H1) Then
                ReaderBuffMgr.PrevLng = 0
                ReaderBuffMgr.count = 0
                ' Show the user the incoming data in hex format
                displaystring = "OK!"
                Me.Invoke(New EventHandler(AddressOf SetText))
            End If
        End Sub


        Private Sub SetText(ByVal o As Object, ByVal e As EventArgs)
            txtOutput.Text = displaystring
        End Sub


        Private Sub btnMagTest_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnMagTest.Click

            'Magstripe_Scan is a simulated buffer of magnetic card data, in this case all pre-fix,postfix data has already been removed.
            Dim Magstripe_Scan As Byte() = HexStringToByteArray("25 4E 59 41 4C 42 41 4E 59 5E 54 4F 4B 45 4E 57 4F 52 4B 53 24 4A 4F 45 34 24 54 5E 38 33 34 20 43 4F 4E 43 48 20 53 48 45 4C 4C 20 52 44 20 20 20 20 23 39 30 31 5E 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 3F 3B 36 33 36 30 31 30 30 33 32 34 31 36 38 33 36 33 31 33 37 3D 30 37 30 32 31 39 38 34 39 39 30 34 30 3D 3F 25 21 20 31 32 33 34 34 30 30 30 30 20 20 45 20 42 20 20 20 20 20 20 20 20 20 20 20 20 20 31 35 30 36 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 4E 2F 26 2B 47 47 30 30 30 30 30 3F")
            Array.Resize(MagBuff, Magstripe_Scan.Length)
            'You MUST resize the data, the buffer sent must contain only card data, no preceding bytes generated by a scanner, and no trailing garbage data. Normally the length is created from the SerialPort.BytesToRead property.
            Array.Copy(Magstripe_Scan, 0, MagBuff, 0, Magstripe_Scan.Length)
            ' copy the scan from your SerialDataReceivedEventHandler into the global MagBuff array
            Try
                ' always call the DLLs with a try/catch
                Me.Invoke(New EventHandler(AddressOf SendMAG))
            Catch
                MessageBox.Show("Invalid Magstripe")
            End Try
            displaystring = MagLib.Magstripe.track1 + MagLib.Magstripe.track2 + MagLib.Magstripe.track3
            ' display the ASCII version of the input data
            Me.Invoke(New EventHandler(AddressOf SetText))



        End Sub

        Private Sub btnPdfTest_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPdfTest.Click

            'BarCode_Scan is a simulated buffer of PDF417 Barcode card data, in this case all pre-fix,postfix data has already been removed.
            Dim BarCode_Scan As Byte() = HexStringToByteArray("40 0A 1C 0D 41 41 4D 56 41 33 36 30 30 31 30 30 31 44 4C 30 30 31 32 33 34 35 36 44 4C 0A 44 41 41 54 4F 4B 45 4E 57 4F 52 4B 53 40 54 4F 4D 40 54 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 0A 44 41 47 34 34 20 45 20 39 39 54 48 20 53 54 20 41 50 54 20 39 30 31 0A 44 41 49 4E 45 57 20 59 4F 52 4B 20 20 20 20 20 20 20 0A 44 41 4A 4E 59 0A 44 41 4B 31 30 31 32 38 20 20 20 20 20 20 0A 44 41 51 33 36 32 38 33 32 35 31 32 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 0A 20 44 42 42 31 39 38 37 30 38 30 32 0A 44 42 44 32 30 30 30 31 30 30 34 0A 44 42 41 32 30 31 33 30 35 30 37 0A 44 41 52 44 4D 20 20 0A 44 41 53 20 20 20 20 20 20 20 20 20 20 0A 44 41 54 20 20 20 20 20 20 0A 44 42 43 4D 0A 44 41 55 36 30 32 0A 44 41 59 42 52 20 0A 44 42 4B 20 20 20 20 20 20 20 20 20 0A 44 42 48 20 20 20 20 20 20 20 20 20 20 0D")
            Array.Resize(buff, BarCode_Scan.Length)
            'You MUST resize the data, the buffer sent must contain only card data, no preceding bytes generated by a scanner, and no trailing garbage data. Normally the length is created from the SerialPort.BytesToRead property.
            Array.Copy(BarCode_Scan, buff, BarCode_Scan.Length)
            ' copy input to global buffer
            Try
                ' always call the DLLs with a try/catch
                Me.Invoke(New EventHandler(AddressOf SendPDF))
            Catch
                MessageBox.Show("Invalid Barcode")
            End Try
            displaystring = PdfLib.Barcode.PDF_String
            ' display the ASCII version of the input data
            Me.Invoke(New EventHandler(AddressOf SetText))

        End Sub

        Private Sub btnClear_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnClear.Click
            txtFirst.Text = ""
            txtLast.Text = ""
            txtMid.Text = ""
            txtTitle.Text = ""
            txtID.Text = ""
            txtState.Text = ""
            txtCity.Text = ""
            txtAddress.Text = ""
            txtEXP.Text = ""
            txtZip.Text = ""
            txtClass.Text = ""
            txtRestriction.Text = ""
            txtEndorseMent.Text = ""
            txtSEX.Text = ""
            txtHeight.Text = ""
            txtWeight.Text = ""
            txtHair.Text = ""
            txtEye.Text = ""
            txtDobMMDD.Text = ""
            txtDobYear.Text = ""
            txtCountry.Text = ""
            txtRace.Text = ""
            txtDBD.Text = ""
            txtAddr2.Text = ""
            txtRetMag.Text = ""
            txtRetPDF.Text = ""
            TxtKeyResp.Text = ""
            TxtParsRev.Text = ""

            displaystring = ""
            Me.Invoke(New EventHandler(AddressOf SetText))
        End Sub

        Private Sub SendMAG(ByVal sender As Object, ByVal e As EventArgs)

            Dim ret As Integer = 0
            Try
                mc = New MagLib.Magstripe()
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Error loading MagLib")

                Return
            End Try

            ret = mc.ParseDL(MagBuff)
            ' Parse the buffer

            stateP_DL = Magstripe.stateP_DL
            cityP_DL = Magstripe.cityP_DL
            addrP_DL = Magstripe.addrP_DL
            firstnameP_DL = Magstripe.firstnameP_DL
            lastnameP_DL = Magstripe.lastnameP_DL
            midnameP_DL = Magstripe.midnameP_DL
            titleP_DL = Magstripe.titleP_DL
            dlP_DL = Magstripe.dlP_DL
            expP_DL = Magstripe.expP_DL
            dobyearP_DL = Magstripe.dobyearP_DL
            dobMMDDP_DL = Magstripe.dobMMDDP_DL
            zipP_DL = Magstripe.zipP_DL
            ClassP_DL = Magstripe.ClassP_DL
            RestrictionsP_DL = Magstripe.RestrictionsP_DL
            EndorsementsP_DL = Magstripe.EndorsementsP_DL
            SexP_DL = Magstripe.SexP_DL
            HeightP_DL = Magstripe.HeightP_DL
            WeightP_DL = Magstripe.WeightP_DL
            HairP_DL = Magstripe.HairP_DL
            EyeColorP_DL = Magstripe.EyeP_DL

            txtFirst.Text = firstnameP_DL
            txtLast.Text = lastnameP_DL
            txtMid.Text = midnameP_DL
            txtTitle.Text = titleP_DL
            txtID.Text = dlP_DL
            txtState.Text = stateP_DL
            txtCity.Text = cityP_DL
            txtAddress.Text = addrP_DL
            txtEXP.Text = expP_DL
            txtZip.Text = zipP_DL
            txtClass.Text = ClassP_DL
            txtRestriction.Text = RestrictionsP_DL
            txtEndorseMent.Text = EndorsementsP_DL
            txtSEX.Text = SexP_DL
            txtHeight.Text = HeightP_DL
            txtWeight.Text = WeightP_DL
            txtHair.Text = HairP_DL
            txtEye.Text = EyeColorP_DL
            txtDobMMDD.Text = dobMMDDP_DL
            txtDobYear.Text = dobyearP_DL
            txtRetMag.Text = ret.ToString()
            TxtParsRev.Text = Magstripe.Version
            TxtKeyResp.Text = Magstripe.KeyResponse


            'These fields are available on barcode only
            txtCountry.Text = ""
            'n/a
            txtRace.Text = ""
            ' n/a
            txtDBD.Text = ""
            ' n/a
            txtAddr2.Text = ""
            ' n/a
            'display return code

        End Sub

        Private Sub SendPDF(ByVal sender As Object, ByVal e As EventArgs)

            Dim i As Integer = -1
            Try
                bc = New PdfLib.Barcode()
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Error loading PdfLib")

                Return
            End Try

            i = bc.Parse417(buff)
            ' Parse the buffer
            stateP_DL = Barcode.State_DL
            cityP_DL = Barcode.City_DL
            addrP_DL = Barcode.Addr_DL
            firstnameP_DL = Barcode.First_DL
            lastnameP_DL = Barcode.Last_DL
            midnameP_DL = Barcode.Mid_DL
            titleP_DL = Barcode.Title_DL
            dlP_DL = Barcode.Dl_DL
            expP_DL = Barcode.Exp_DL
            dobyearP_DL = Barcode.DobYear_DL
            dobMMDDP_DL = Barcode.DobMMDD_DL
            zipP_DL = Barcode.Zip_DL
            HeightP_DL = Barcode.Height_DL
            EyeColorP_DL = Barcode.Eye_DL
            SexP_DL = Barcode.Sex_DL
            ClassP_DL = Barcode.Class_DL
            RestrictionsP_DL = Barcode.Rest_DL
            EndorsementsP_DL = Barcode.Endr_DL
            WeightP_DL = Barcode.Wt_DL
            HairP_DL = Barcode.Hair_DL

            'Loading Gui Object from local app variables
            txtFirst.Text = firstnameP_DL
            txtLast.Text = lastnameP_DL
            txtMid.Text = midnameP_DL
            txtAddress.Text = addrP_DL
            txtCity.Text = cityP_DL
            txtState.Text = stateP_DL
            txtZip.Text = zipP_DL
            txtID.Text = dlP_DL
            txtSEX.Text = SexP_DL
            txtEXP.Text = expP_DL
            txtTitle.Text = titleP_DL
            txtEye.Text = EyeColorP_DL
            txtHeight.Text = HeightP_DL
            txtDobMMDD.Text = dobMMDDP_DL
            txtDobYear.Text = dobyearP_DL
            txtClass.Text = ClassP_DL
            txtRestriction.Text = RestrictionsP_DL
            txtEndorseMent.Text = EndorsementsP_DL
            txtWeight.Text = WeightP_DL
            txtHair.Text = HairP_DL
            txtRetPDF.Text = i.ToString()
            TxtParsRev.Text = Barcode.Version
            TxtKeyResp.Text = Barcode.KeyResponse


            ' loading directly from library

            'These fields are available on barcode only
            txtAddr2.Text = Barcode.Addr2_DL
            txtCountry.Text = Barcode.Country_DL
            txtRace.Text = Barcode.Race_DL
            txtDBD.Text = Barcode.DocIssDate_DL

        End Sub

        Private Sub btnPort_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPort.Click
            Dim settings As New frmSettings()
            settings.ShowDialog()
        End Sub

        Private Sub btnOpenPort_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnOpenPort.Click
            ' If the port is open, close it.
            If comport.IsOpen Then
                comport.Close()
            Else
                ' comport.BaudRate = Settings.Default.BaudRate
                ' comport.DataBits = Settings.Default.DataBits
                ' comport.StopBits = Settings.[Default].StopBits
                ' comport.Parity = Settings.[Default].Parity
                ' comport.PortName = Settings.[Default].PortName
                comport.BaudRate = 9600
                comport.DataBits = 8
                comport.StopBits = System.IO.Ports.StopBits.One
                comport.Parity = System.IO.Ports.Parity.None
                comport.PortName = portz


                ' Open the port
                Try
                    comport.Open()
                Catch px As Exception
                    MessageBox.Show(px.Message, "Port already in use")


                End Try
            End If
            If comport.IsOpen Then
                btnOpenPort.Text = "&Close Port"
                btnMagTest.Enabled = False

                btnPdfTest.Enabled = False
            Else

                btnOpenPort.Text = "&Open Port"
                btnMagTest.Enabled = True

                btnPdfTest.Enabled = True
            End If
        End Sub

        Private Sub btnTest2_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnTest2.Click
            If comport.IsOpen Then
                'this commands pings the port to see if the reader is connected

                Dim data1 As Byte() = HexStringToByteArray("01 3C 54 58 50 49 4E 47 3A 3E 04")
                '
                ' Send the binary data out the port
                comport.Write(data1, 0, data1.Length)
            End If

        End Sub

        Private Sub btnProgram_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnProgram.Click
            If comport.IsOpen Then
                'this sets prefix for reader to work with DataReceiveEvent
                Dim data As Byte() = HexStringToByteArray("01 3C 4E 4F 52 45 41 44 3D 31 3E 3C 50 52 45 43 49 44 3D 31 3E 3C 50 52 45 46 49 58 3D 5B 53 4F 48 5D 5B 53 54 58 5D 3E 3C 53 55 46 46 49 58 3D 5B 45 54 58 5D 5B 45 4F 54 5D 3E 3C 53 45 52 49 41 4C 3A 3E 04")

                ' Send the binary data out the port
                comport.Write(data, 0, data.Length)
            End If

        End Sub

#End Region

    End Class
End Namespace
